unit bhjournal;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  StdCtrls, Forms, DBCtrls, DB, DBGrids, DBTables, Grids, ExtCtrls,
  DBCGrids, ComCtrls, Buttons, dialogs, inifiles, printers, Menus;

type
  T_Journal = class(TForm)
    DS_Journal: TDataSource;
    Panel2: TPanel;
    J: TTable;
    Grid: TDBCtrlGrid;
    anr: TDBText;
    beleg: TDBText;
    Bnr: TDBText;
    HabenBetrag: TDBText;
    Ok: TDBText;
    Buchtext: TDBText;
    HabenKnt: TDBText;
    UstHaben: TDBText;
    UstKnt: TDBText;
    UstP: TDBText;
    UstSaldo2: TDBText;
    UstSoll: TDBText;
    Datum: TDBText;
    Label10: TLabel;
    SollKnt: TDBText;
    SollBetrag: TDBText;
    habenSaldo: TDBText;
    SollSaldo: TDBText;
    Panel1: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    B_DruJournal: TSpeedButton;
    JBnr: TAutoIncField;
    JSollKnt: TStringField;
    JHabenKnt: TStringField;
    JUstKnt: TStringField;
    JUstP: TSmallintField;
    JSollBetrag: TBCDField;
    JHabenBetrag: TBCDField;
    JUstSoll: TBCDField;
    JUstHaben: TBCDField;
    JBuchtext: TStringField;
    JAnr: TSmallintField;
    JBeleg: TStringField;
    JDatum: TDateField;
    JSollSaldo2: TBCDField;
    JHabenSaldo2: TBCDField;
    JUstSaldo2: TBCDField;
    JOk: TStringField;
    SucheText: TEdit;
    sucheNext: TSpeedButton;
    sucheLast: TSpeedButton;
    Label1: TLabel;
    sucheBnr: TEdit;
    Label2: TLabel;
    Label11: TLabel;
    PopupMenu1: TPopupMenu;
    UpdateSollHabenKontoimHauptbuchKontoplan1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure B_DruJournalClick(Sender: TObject);
    procedure sucheNextClick(Sender: TObject);
    procedure sucheLastClick(Sender: TObject);
    procedure B_sucheBnrClick(Sender: TObject);
    procedure GridClick(Sender: TObject);
    procedure SucheTextKeyPress(Sender: TObject; var Key: Char);
    procedure sucheBnrChange(Sender: TObject);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  _Journal: T_Journal;

implementation

uses bhdru_J1, bhkonto, bhplan, bhbuchen;

{$R *.DFM}

procedure T_Journal.FormCreate(Sender: TObject);
var Inifile :TIniFile;
begin
J.Open;
Inifile:= TIniFile.Create('.\HuBH.Ini');
try
 inifile.writedate('Datum','Buchung1',Jdatum.Value);
finally
 Inifile.Free;
end;
end;

procedure T_Journal.FormResize(Sender: TObject);
begin
//grid.height:=panel2.height-14;
grid.rowcount:=panel2.height div 60;
end;

procedure T_Journal.B_DruJournalClick(Sender: TObject);
var seite :string;
    Inifile :TIniFile;
begin
Inifile:= TIniFile.Create('.\HuBH.Ini');
try
 seite:=inifile.readString('Journaldruck','Seite','0');
 finally
 Inifile.Free;
end;
showmessage('Zuletzt wurde JOURNAL-Seite " '+seite+
   ' " gedruckt. Druckanfang evt. mit PrinterSetup einstellen!');
_druJournal.report.Preview;
end;

procedure T_Journal.sucheNextClick(Sender: TObject);
var betrag:currency;
begin
j.DisableControls;
try
 try betrag:=strToFloat(sucheText.text);
  repeat
    j.prior;
  until j.bof or (Betrag=jSollBetrag.value) or (Betrag=jHabenBetrag.value)
              or (Betrag=jUstSoll.value) or (Betrag=jUstHaben.value);
 except
  repeat
    j.prior;
  until j.bof or (pos(sucheText.text,ansiuppercase(jBuchtext.text))>0);
  end;
finally
 j.EnableControls;
 sucheBnr.text:=jbnr.text;
 if _buchen.habenKnt.focused
 then _kontoplan.suchwort.text:=jHabenKnt.text
 else _kontoplan.suchwort.text:=jSollKnt.text;
end;
end;

procedure T_Journal.sucheLastClick(Sender: TObject);
begin
j.last;
sucheNextClick(sender);
end;

procedure T_Journal.B_sucheBnrClick(Sender: TObject);
begin
sucheBnr.text:=sucheText.text;
end;

procedure T_Journal.GridClick(Sender: TObject);
begin
if (jOK.text=GESICHERT) or (jOK.text=GEBUCHT) then begin
  _kontoplan.windowstate:=wsNormal;
  _konto.fixeKontowahl.checked:=false;
  if _kontoplan.suchwort.text=jSollKnt.text
  then _kontoplan.suchwort.text:=jHabenKnt.text
  else _kontoplan.suchwort.text:=jSollKnt.text;
  _konto.k2.locate('BNR',jBnr.text,[]);
end;
end;

procedure T_Journal.SucheTextKeyPress(Sender: TObject; var Key: Char);
begin
if key=#13 then begin
  if j.bof then sucheLastClick(sender)
  else sucheNextClick(sender);
  key:=#0;
  end;
end;

procedure T_Journal.sucheBnrChange(Sender: TObject);
begin
j.DisableControls;
try
  j.last;
  if sucheBnr.text='' then exit;
  repeat
    j.prior
  until j.bof or (jBnr.text=sucheBnr.text);
finally
  j.EnableControls;
end;
end;

procedure T_Journal.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
//j.prior;
end;

procedure T_Journal.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
//j.next;
end;

end.


